﻿-- Create Date : 28/10/2013 9:44:01 PM				
local BtnActiveRT = CreateFrame("Button", nil, UIParent, "UIPanelButtonTemplate")
BtnActiveRT:SetFrameStrata("DIALOG")
BtnActiveRT:SetWidth(80)
BtnActiveRT:SetHeight(30)
BtnActiveRT:SetPoint("TOPLEFT", 5, -20)
BtnActiveRT:SetFrameLevel(129)
BtnActiveRT:RegisterEvent("CHAT_MSG_TEXT_EMOTE")
BtnActiveRT:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
BtnActiveRT:RegisterEvent("UI_ERROR_MESSAGE")

local FrmLabelSpell = CreateFrame('Frame', nil, UIParent)
local TituloLabelSpell = FrmLabelSpell:CreateFontString(nil, "ARTWORK", "GameTooltipText")
local BackDropLabelSpell = {
								bgFile = [[Interface\ChatFrame\ChatFrameBackground]], tile = true, tileSize = 16,
								edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]], edgeSize = 16,
								insets = {left = 4, right = 4, top = 4, bottom = 4},
							}
		
TituloLabelSpell:SetPoint("TOPLEFT", 4, -5)
FrmLabelSpell.title = TituloLabelSpell
FrmLabelSpell:SetPoint("CENTER", 0, -180)
FrmLabelSpell:SetSize(120, 22)
FrmLabelSpell:SetFrameStrata("BACKGROUND")

FrmLabelSpell:SetFrameLevel(129)
FrmLabelSpell:SetBackdrop(BackDropLabelSpell)
FrmLabelSpell:SetBackdropColor(.1, .1, .1, 1)
FrmLabelSpell:SetBackdropBorderColor(.3, .3, .3, 1)

local FrmImageRT = CreateFrame("Frame", nil, UIParent)

FrmImageRT:SetFrameStrata("BACKGROUND")
FrmImageRT:SetSize(40, 40)
FrmImageRT:SetPoint("CENTER", 0, -150)
FrmImageRT:SetFrameLevel(129)

local TextureImageRT = FrmImageRT:CreateTexture(nil,"DIALOG")
TextureImageRT:SetAllPoints(FrmImageRT)	

BtnActiveRT:Show()
FrmLabelSpell:Hide()

local ActiveRT = false
function BtnActiveRT:OnClick()
	if not ActiveRT then 
		print("Guga was Started!")
		ActiveRT = true
		BtnActiveRT:SetText("Stop Guga")
	else
		print("Guga was Stopped!")
		ActiveRT = false
		BtnActiveRT:PlayerAction(nil)--Clear
		BtnActiveRT:SetText("Start Guga")		
	end
end

local CurTimer = 0
local UpdateTimer = 0
local MaxUpdate = 0.1
function BtnActiveRT:OnUpdate()
	if ActiveRT then
		CurTimer = GetTime()
		if (CurTimer - UpdateTimer >= MaxUpdate) then
			UpdateTimer = CurTimer
			BtnActiveRT:PlayerAction(BtnActiveRT:Main())
		end
	end
end

local PRESENCE_BLOOD, PRESENCE_FROST, PRESENCE_UNHOLY = 1, 2, 3
local NUM_TABLE_SLOTS = 120
local MAX_RUNES_FROST_STRIKE = 25
local MAX_RUNES_PLAGUE_STRIKE = 10
local MAX_SOUL_REAPER_LIFE = 0.35
local NAME_ADDON_BAR = "BT4Button"
local MIN_BLOOD_CHARGE = 5
local MIN_OUTBREAK = 30
local MIN_CONVERTION = 10
local MIN_LIFE = 0.8
local MAX_TIME_MSG = 5
local MAX_TIME_EMOTE = 5
local MSG_SAY_ALL = false

local Behind = false

local PlayerSpell = { 	 
						 ["Death Coil"] = GetSpellInfo(47541),--Espiral da Morte
						 ["Chains of Ice"] = GetSpellInfo(45524),--Correntes de Gelo
						 ["Chilblains"] = GetSpellInfo(50435),--Perniose
						 ["Anti-Magic Shell"] = GetSpellInfo(48707),--Carapaça Antimagia
						 ["Death and Decay"] = GetSpellInfo(43265),--Morte e Decomposição
						 ["Obliterate"] = GetSpellInfo(49020),--Obliterar
						 ["Howling Blast"] = GetSpellInfo(49184),--Impacto Uivante
						 ["Death Grip"] = GetSpellInfo(49576),--Garra da Morte
						 ["Dark Simulacrum"] = GetSpellInfo(77606),--Simulacro Negro
						 ["Army of the Dead"] = GetSpellInfo(42650),--Exército dos Mortos
						 ["Remorseless Winter"] = GetSpellInfo(108200),--Inverno Impiedoso
						 ["Frost Fever"] = GetSpellInfo(55095),--Febre do Gelo
						 ["Blood Plague"] = GetSpellInfo(55078),--Peste Sanguínea
						 ["Shadowmeld"] = GetSpellInfo(58984),--Fusão Sombria
						 ["Path of Frost"] = GetSpellInfo(3714),--Caminho de Gelo
						 ["Blood Presence"] = GetSpellInfo(48263),--Presença Sanguínea
						 ["Frost Presence"] = GetSpellInfo(48266),--Presença Gélida
						 ["Unholy Presence"] = GetSpellInfo(48265),--Presença Profana
						 ["Asphyxiate"] = GetSpellInfo(108194),--Asfixiar
						 ["Strangulate"] = GetSpellInfo(47476),--Estrangular
						 ["Call of Victory"] = GetSpellInfo(84966),--Chamado da Vitória	
						 ["Surge of Victory"] = GetSpellInfo(105139),--Surto de Vitória	
						 ["Pillar of Frost"] = GetSpellInfo(51271),--Pilar de Gelo
						 ["Mind Freeze"] = GetSpellInfo(47528),--Congelar Mente
						 ["Frost Strike"] = GetSpellInfo(49143),--Golpe Gélido
						 ["Lichborne"] = GetSpellInfo(49039),--Forma Decadente
						 ["Icebound Fortitude"] = GetSpellInfo(48792),--Fortitude Congélida
						 ["Dark Succor"] = GetSpellInfo(101568),--Socorro Negro
						 ["Death Strike"] = GetSpellInfo(49998),--Golpe da Morte
						 ["Outbreak"] = GetSpellInfo(77575),--Eclosão
						 ["Unholy Blight"] = GetSpellInfo(115989),--Devastação Profana
						 ["Raise Dead"] = GetSpellInfo(46584),--Reviver Morto
						 ["Death Pact"] = GetSpellInfo(48743),--Pacto da Morte
						 ["Plague Strike"] = GetSpellInfo(45462),--Golpe da Peste
						 ["Killing Machine"] = GetSpellInfo(51124),--Máquina Assassina
						 ["Freezing Fog"] = GetSpellInfo(59052),--Nevoeiro Congelante
						 ["Horn of Winter"] = GetSpellInfo(57330),--Berrante do Inverno
						 ["Empower Rune Weapon"] = GetSpellInfo(47568),--Energizar Arma Rúnica
						 ["Soul Reaper"] = GetSpellInfo(130735),--Ceifador de Almas
						 ["Blood Boil"] = GetSpellInfo(50842),--Sangue Fervente
						 ["Death Siphon"] = GetSpellInfo(108196),--Sifão da Morte
						 ["Blood Tap"] = GetSpellInfo(45529),--Transfusão de Sangue
						 ["Blood Charge"] = GetSpellInfo(114851),--Carga de Sangue
						 ["Plague Leech"] = GetSpellInfo(123693),--Sugar Peste
						 ["Conversion"] = GetSpellInfo(119975),--Conversão
						 ["Icy Touch"] = GetSpellInfo(45477),--Toque Gélido
						 ["Desecrated Ground"] = GetSpellInfo(108201),--Solo Profanado
						 ["Defile"] = GetSpellInfo(152280),--Profanar
						 ["Necrotic Plague"] = GetSpellInfo(155159),--Peste Necrótica
						 ["Call to Arms"] = GetSpellInfo(161676),--Chamado às Armas
						 ["Artillery Strike"] = GetSpellInfo(162075),--Ataque de Artilharia
						 ["Telaari Talbuk"] = GetSpellInfo(165803),--Talbuque Telaari
						 ["Summon Mechashredder 5000"] = GetSpellInfo(164050),--Evocar Meca-retalhador 5000
						 ["Raise Ally"] = GetSpellInfo(61999)--Reviver Aliado	
					}
			   
local PlayerGlyph = {   
						 ["Glyph Path of Frost"] = GetSpellInfo(59307),--Glifo de Caminho de Gelo
						 ["Glyph Death Grip"] = GetSpellInfo(62259),--Glifo de Garras da Morte
						 ["Glyph of Outbreak"] = GetSpellInfo(59339),--Glifo de Eclosão
						 ["Glyph of Shifting Presences"] = GetSpellInfo(58647),--Glifo de Presenças Cambiantes
						 ["Glyph of Death and Decay"] = GetSpellInfo(58629),--Glifo de Morte e Decomposição
						 ["Glyph of Empowerment"] = GetItemInfo(110803),--Glifo de Potencialização
						 ["Glyph of Icy Touch"] = GetItemInfo(43546)--Glifo de Toque Gélido
					 }

local TargetSpell = { 
						["Touch of Karma"] = GetSpellInfo(122470),--Toque do Karma
						["Avenger's Shield"] = GetSpellInfo(31935)--Escudo do Vingador
			   }
		
local SpellSilence = {  
						["Asphyxiate"] = GetSpellInfo(108194),--Asfixiar
						["Fist of Justice"] = GetSpellInfo(105593),--Punho da Justiça
						["Frostjaw"] = GetSpellInfo(102051),--Necrose de Gelo
						["Hex"] = GetSpellInfo(51514),--Bagata
						["Fear"] = GetSpellInfo(5782),--Medo						
						["Blinding Light"] = GetSpellInfo(115750),--Luz Ofuscante
						["Cyclone"] = GetSpellInfo(33786),--Ciclone	
						["Polymorph"] = GetSpellInfo(118),--Polimorfia
						["Psychic Scream"] = GetSpellInfo(8122),--Grito Psíquico
						["Silence"] = GetSpellInfo(15487),--Silêncio
						["Sleep"] = GetSpellInfo(31298),--Sono						
						["Hammer of Justice"] = GetSpellInfo(853),--Martelo da Justiça		
						["Ring of Frost"] = GetSpellInfo(113724),--Anel Gélido						
						["Fully Petrified"] = GetSpellInfo(115877)--Totalmente Petrificado
					 }
					 
local TargetDisspell = {  
						   ["Ice Ward"] = GetSpellInfo(111264),--Proteção de Gelo--
						   ["Dark Intent"] = GetSpellInfo(109773),--Intenção Sombria--
						   ["Power Word: Fortitude"] = GetSpellInfo(21562),--Palavra de Poder: Fortitude--
						   ["Power Word: Shield"] = GetSpellInfo(17),--Palavra de Poder: Escudo--
						   ["Fear Ward"] = GetSpellInfo(6346),--Proteção contra Medo--
						   ["Blessing of Kings"] = GetSpellInfo(20217),--Bênção dos Reis--
						   ["Mark of the Wild"] = GetSpellInfo(1126),--Marca do Indomado--
						   ["Rejuvenation"] = GetSpellInfo(774),--Rejuvenescer--
						   ["Dalaran Brilliance"] = GetSpellInfo(61316),--Inteligência de Dalaran--
						   ["Hand of Freedom"] = GetSpellInfo(1044),--Mão da Liberdade--
						   ["Blessing of Might"] = GetSpellInfo(19740),--Bênção do Poder--
						   ["Righteous Determination"] = GetSpellInfo(165889),--Determinação Íntegra--
						   ["Time Warp"] = GetSpellInfo(80353),--Distorção Temporal--
						   ["Unleashed Fury"] = GetSpellInfo(118470),--Fúria Liberada--	
						   ["Selfless Healer"] = GetSpellInfo(114250),--Curador Abnegado--
						   ["Arcane Brilliance"] = GetSpellInfo(1459),--Inteligência Arcana--
						   ["Freezing Fog"] = GetSpellInfo(59052),--Nevoeiro Congelante--	
						   ["Lunar Empowerment"] = GetSpellInfo(164547),--Potencialização Lunar--
						   ["Backdraft"] = GetSpellInfo(117828),--Ignição Explosiva--
						   ["Amplify Magic"] = GetSpellInfo(159916),--Amplificar Magia--
						   ["Archangel"] = GetSpellInfo(81700),--Arcanjo--
						   ["Natures Grasp"] = GetSpellInfo(170856),--Enredamento--
						   ["Clearcasting"] = GetSpellInfo(16870),--Abstração--
						   ["Glyph of Denounce"] = GetSpellInfo(115654),--Glifo de Condenar--
						   ["Spirit Mend"] = GetSpellInfo(90361),--Recomposição Espiritual--
						   ["Cadentes Stars"] = GetSpellInfo(93399),--Estrelas Cadentes--	
						   ["Shooting Stars"] = GetSpellInfo(157228),--Luniscante Potencializado--						   
						   ["Blinding Light"] = GetSpellInfo(115750),--Luz Ofuscante--	
						   ["Legacy of the White Tiger"] = GetSpellInfo(116781),--Legado do Tigre Branco--	
						   ["Legacy of the Emperor"] = GetSpellInfo(115921),--Legado do Imperador--	
						   ["Zen Sphere"] = GetSpellInfo(124081),--Esfera Zen--	
						   ["Riptide"] = GetSpellInfo(61295),--Contracorrente--	
						   ["Spiritwalkers Grace"] = GetSpellInfo(79206),--Graça do Andarilho Espiritual--	
						   ["Body and Soul"] = GetSpellInfo(65081),--Corpo e Alma--	
						   ["Renewing Mist"] = GetSpellInfo(119611),--Brumas da Renovação--	
						   ["Fire Ward"] = GetSpellInfo(37844),--Proteção contra Fogo	
						   ["Surge of Darkness"] = GetSpellInfo(87160),--Torrente de Escuridão	
						   ["Frost Ward"] = GetSpellInfo(15044),--Proteção contra Gelo
						   ["Divine Insight"] = GetSpellInfo(109175),--Intuição Divina
						   ["Surge of Darkness"] = GetSpellInfo(87160),--Torrente de Escuridão						   
						   ["Prayer of Mending"] = GetSpellInfo(33076),--Prece da Recomposição
						   ["Power Infusion"] = GetSpellInfo(10060),--Infusão de Poder--
						   ["Levitate"] = GetSpellInfo(1706),--Levitar	--			   
						   ["Ancestral Swiftness"] = GetSpellInfo(16188),--Rapidez Ancestral--
						   ["Earth Shield"] = GetSpellInfo(974),--Escudo da Terra--
						   ["Hand of Protection"] = GetSpellInfo(1022),--Mão da Proteção--
						   ["Hand of Sacrifice"] = GetSpellInfo(6940),--Mão do Sacrifício--
						   ["Hand of Purity"] = GetSpellInfo(114039),--Mão da Pureza--
						   ["Speed of Light"] = GetSpellInfo(85499),--Velocidade da Luz--
						   ["Icy Veins"] = GetSpellInfo(12472),--Veias Gélidas--
						   ["Ice Barrier"] = GetSpellInfo(11426),--Barreira de Gelo--
						   ["Alter Time"] = GetSpellInfo(108978),--Alterar o Tempo--
						   ["Illuminated Healing"] = GetSpellInfo(86273),--Cura Iluminada--
						   ["Presence of Mind"] = GetSpellInfo(12043),--Presença de Espírito--						   
						   ["Arcane Power"] = GetSpellInfo(12042),--Poder Arcano--
						   ["Lifebloom"] = GetSpellInfo(33763),--Brotar da Vida--
						   ["Genesis"] = GetSpellInfo(145518),--Gênese--
						   ["Predatory Swiftness"] = GetSpellInfo(69369),--Velocidade Predatória--
						   ["Nature Swiftnesss"] = GetSpellInfo(132158),--Rapidez da Natureza--
						   ["Celestial Fury"] = GetSpellInfo(180719),--Fúria Celestial--
						   ["Arcane Intellect"] = GetSpellInfo(45525)--Intelecto Arcano--
						}	

local CastingFear = {  
						["Frostjaw"] = GetSpellInfo(102051),--Necrose de Gelo
						["Hex"] = GetSpellInfo(51514),--Bagata
						["Fear"] = GetSpellInfo(5782),--Medo						
						["Cyclone"] = GetSpellInfo(33786),--Ciclone	
						["Polymorph"] = GetSpellInfo(118)--Polimorfia
					   }
					   
local SilenceImmunezed = {   	
							["Trinket01"] = GetItemInfo(125977),--Medalhão da Crueldade do Gladiador Pugnaz
							["Trinket02"] = GetItemInfo(125978),--Medalhão da Adaptação do Gladiador Pugnaz
							["Trinket03"] = GetItemInfo(125979),--Medalhão da Tenacidade do Gladiador Pugnaz
							["Trinket04"] = GetItemInfo(125980),--Medalhão da Meditação do Gladiador Pugnaz
							["Trinket05"] = GetItemInfo(126456),--Medalhão da Tenacidade do Gladiador Pugnaz
							["Trinket06"] = GetItemInfo(126457),--Medalhão da Meditação do Gladiador Pugnaz
							["Trinket07"] = GetItemInfo(127125),--Medalhão da Adaptação do Gladiador Pugnaz
							["Trinket08"] = GetItemInfo(127126),--Medalhão da Crueldade do Gladiador Pugnaz
							["Trinket09"] = GetItemInfo(124863),--Medalhão da Crueldade do Gladiador Selvagem
							["Trinket10"] = GetItemInfo(124864),--Medalhão da Adaptação do Gladiador Selvagem
							["Trinket11"] = GetItemInfo(124865),--Medalhão da Tenacidade do Gladiador Selvagem
							["Trinket12"] = GetItemInfo(124866),--Medalhão da Meditação do Gladiador Selvagem
							["Trinket13"] = GetItemInfo(125342),--Medalhão da Tenacidade do Gladiador Selvagem
							["Trinket14"] = GetItemInfo(125343),--Medalhão da Meditação do Gladiador Selvagem
							["Trinket15"] = GetItemInfo(127123),--Medalhão da Adaptação do Gladiador Selvagem
							["Trinket16"] = GetItemInfo(127124),--Medalhão da Crueldade do Gladiador Selvagem
							["Trinket17"] = GetItemInfo(127673),--Medalhão da Adaptação do Gladiador do Torneio
							["Trinket18"] = GetItemInfo(127674),--Medalhão da Adaptação do Gladiador do Torneio
							["Trinket19"] = GetItemInfo(126151),--Medalhão da Crueldade do Combatente Pugnaz
							["Trinket20"] = GetItemInfo(126152),--Medalhão da Adaptação do Combatente Pugnaz
							["Trinket21"] = GetItemInfo(126153),--Medalhão da Tenacidade do Combatente Pugnaz
							["Trinket22"] = GetItemInfo(126154),--Medalhão da Meditação do Combatente Pugnaz
							["Trinket23"] = GetItemInfo(126628),--Medalhão da Crueldade do Combatente Pugnaz
							["Trinket24"] = GetItemInfo(126629),--Medalhão da Adaptação do Combatente Pugnaz
							["Trinket25"] = GetItemInfo(126630),--Medalhão da Tenacidade do Combatente Pugnaz
							["Trinket26"] = GetItemInfo(126631),--Medalhão da Meditação do Combatente Pugnaz
							["Nimble Brew"] = GetSpellInfo(137562),--Cerveja Ligeira
							["Deterrence"] = GetSpellInfo(19263),--Coibição
							["Unending Resolve"] = GetSpellInfo(104773),--Determinação Interminável
							["Ice Block"] = GetSpellInfo(45438),--Bloco de Gelo	
							["Spell Reflection"] = GetSpellInfo(23920),--Reflexão de Feitiço
							["Divine Shield"] = GetSpellInfo(642)--Escudo Divino
					   }
	
local AtackImmunezed = {  
						["Deterrence"] = GetSpellInfo(19263),--Coibição
						["Unending Resolve"] = GetSpellInfo(104773),--Determinação Interminável
						["Mass Spell Reflection"] = GetSpellInfo(114028),--Reflexão de Feitiço em Massa
						["Bladestorm"] = GetSpellInfo(46924),--Tornado de Aço
						["Diffuse Magic"] = GetSpellInfo(122783),--Magia Difusa
						["Ice Block"] = GetSpellInfo(45438),--Bloco de Gelo	
						["Divine Shield"] = GetSpellInfo(642),--Escudo Divino
						["Cyclone"] = GetSpellInfo(33786),--Ciclone	
						["Anti-Magic Shell"] = GetSpellInfo(48707),--Carapaça Antimagia
						["Fear"] = GetSpellInfo(5782),--Medo	
						["Hex"] = GetSpellInfo(51514),--Bagata
						["Polymorph"] = GetSpellInfo(118),--Polimorfia
						["Frostjaw"] = GetSpellInfo(102051),--Necrose de Gelo
						["Psychic Scream"] = GetSpellInfo(8122)--Grito Psíquico
					 }
				
local SpellFrozen = {  
						["Chains of Ice"] = GetSpellInfo(45524),--Correntes de Gelo
						["Entangling Roots"] = GetSpellInfo(339)--Raízes Enredantes
				    }
					   
local FrozenImmunezed = {  
							["Master Call"] = GetSpellInfo(53271),--Chamado do Mestre
							["Avatar"] = GetSpellInfo(107574),--Avatar
							["Burst of Speed"] = GetSpellInfo(108212),--Estouro de Velocidade
							["Phantasm"] = GetSpellInfo(108942)--Fantasma
						}
	
local PlayerItem = {	
						["Frost Grenade"] = GetItemInfo(32413),--Granada de Gelo
						["Hardened Shell"] = GetItemInfo(86584),--Casca Endurecida
						["Super Sticky Glitter Bomb"] = GetItemInfo(119216)--Bomba Brilhante Supergrudenta
					}	
					
function BtnActiveRT:OnEvent(event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11)
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		if arg2 == "SPELL_HEAL" then
			if arg9 == UnitName("player") and arg5 ~= UnitName("player") then				
				BtnActiveRT:EmoteNow(arg5, 3)
			end			
		end
	elseif event == "UI_ERROR_MESSAGE" then		
		BtnActiveRT:BehindNow((string.find(arg1, "behind") ~= nil or string.find(arg1, "frente") ~= nil or string.find(arg1, "Vire") ~= nil) and not IsMounted() and not IsFalling())
	elseif event == "CHAT_MSG_TEXT_EMOTE" then
		if UnitName("player") ~= arg2 then
			englishFaction, localizedFaction = UnitFactionGroup("target")

			if englishFaction == "Horde" then
				BtnActiveRT:EmoteNow(arg2, 1)
			else
				BtnActiveRT:EmoteNow(arg2, 2)
			end			
		end
	end
end

BtnActiveRT:OnClick()
		
BtnActiveRT:SetScript("OnClick", BtnActiveRT.OnClick)
BtnActiveRT:SetScript("OnUpdate", BtnActiveRT.OnUpdate)
BtnActiveRT:SetScript("OnEvent", BtnActiveRT.OnEvent)

function BtnActiveRT:PlayerAction(spell)
	TituloLabelSpell:SetText("")--Clear
	TextureImageRT:Hide()	
	FrmLabelSpell:Hide()
	
	if spell ~= nil then		
		local name, rank, icon = GetSpellInfo(spell)
		TextureImageRT:SetTexture(icon)
		TituloLabelSpell:SetText(strsub(spell,1,17)) 
		FrmImageRT.texture = TextureImageRT
		TextureImageRT:Show()
		FrmLabelSpell:Show()
	end
end

local CurTimerBehind = 0		
local UpdateTimerBehind = 0
function BtnActiveRT:BehindNow(action)
	CurTimerBehind = GetTime()
	
	if (CurTimerBehind - UpdateTimerBehind > 0.1) then
		UpdateTimerBehind = CurTimerBehind
		Behind = action
	end
end

local emoteChange1, emoteChange2, emoteChange3 = 0, 0, 0
local CurTimerEmote = 0		
local UpdateTimerEmote = 0
function BtnActiveRT:EmoteNow(target, ty)
	CurTimerEmote = GetTime()
	
	if (CurTimerEmote - UpdateTimerEmote > MAX_TIME_EMOTE) then
		UpdateTimerEmote = CurTimerEmote
		
		if ty == 1 then
			MAX_TIME_EMOTE = 5
			emoteChange1 = emoteChange1 + 1
			if emoteChange1 == 1 then
				DoEmote("insult", target)
			elseif emoteChange1 == 2 then
				DoEmote("mock", target)
			elseif emoteChange1 == 3 then
				DoEmote("no", target)			
			elseif emoteChange1 == 4 then
				DoEmote("CHICKEN", target)		
			elseif emoteChange1 == 5 then
				DoEmote("bye", target)		
			else
				DoEmote("rofl", target)
				emoteChange1 = 0
			end
		elseif ty == 2 then
			MAX_TIME_EMOTE = 30
			DoEmote("thank", target)
			emoteChange2 = 0
		else
			MAX_TIME_EMOTE = 30
			emoteChange3 = emoteChange3 + 1
			if emoteChange3 == 1 then
				DoEmote("victory", target)
			elseif emoteChange3 == 2 then
				DoEmote("happy", target)
			else
				DoEmote("applaud", target)
				emoteChange3 = 0
			end									
		end	
	end
end

MOD_TextFrame = CreateFrame("Frame");
MOD_TextFrame:ClearAllPoints();
MOD_TextFrame:SetHeight(300);
MOD_TextFrame:SetWidth(450);
MOD_TextFrame:Hide();
MOD_TextFrame.text = MOD_TextFrame:CreateFontString(nil, "BACKGROUND", "PVPInfoTextFont");
MOD_TextFrame.text:SetAllPoints();
MOD_TextFrame:SetPoint("CENTER", 0, -200);
MOD_TextFrameTime = 0;

local CurTimerMSGFade = 0		
local UpdateTimerMSGFade = 0
function MOD_TextFrame_OnUpdate()
	CurTimerMSGFade = GetTime()
	local alpha = MOD_TextFrame:GetAlpha()

	if (CurTimerMSGFade - UpdateTimerMSGFade > 1) then	
		UpdateTimerMSGFade = CurTimerMSGFade
		if (alpha ~= 0) then MOD_TextFrameTime = MOD_TextFrameTime +1 else MOD_TextFrameTime = 0 end
	elseif MOD_TextFrameTime >= 2 then		
		if (alpha == 0) then 
			MOD_TextFrame:Hide() 
			MOD_TextFrameTime = 0
		elseif (alpha > 0) then
			MOD_TextFrame:SetAlpha(alpha - 0.01)
		end
	end
end

MOD_TextFrame:SetScript("OnUpdate", MOD_TextFrame_OnUpdate);

local CurTimerMSG = 0		
local UpdateTimerMSG = 0
local msgAux = ""
function BtnActiveRT:SendMessage(msg, all)
	CurTimerMSG = GetTime()
	
	if (CurTimerMSG - UpdateTimerMSG > MAX_TIME_MSG or msgAux ~= msg) then
		UpdateTimerMSG = CurTimerMSG
		
		if all then
			SendChatMessage(msg, "SAY")
		end
	end

	local alpha = MOD_TextFrame:GetAlpha()
	if (MOD_TextFrameTime == 0 or msgAux ~= msg) then 
		PlaySound("RaidWarning") 
		msgAux = msg
	end

	CurTimerMSGFade = 0		
	UpdateTimerMSGFade = 0
	MOD_TextFrameTime = 0;
	MOD_TextFrame.text:SetText(strsub(msg,1,80));
	MOD_TextFrame:SetAlpha(1);
	MOD_TextFrame:Show();	
end

function BtnActiveRT:FormatTime(timeleft)
	if timeleft == nil or timeleft < 0 then timeleft = 0 end
	timeleft = ceil(timeleft)
	return timeleft
end	
			
function BtnActiveRT:GetTimeDebuff(unit, debuff)
	local time, expires = 0, select(7,UnitDebuff(unit, debuff))
	
	if expires ~= nil then
		time = expires - GetTime() 
	else--Verify again
		local a = UnitDebuff(unit, debuff)	
		if a ~= nil then time = 1 end
	end 
	
	return BtnActiveRT:FormatTime(time)
end

function BtnActiveRT:GetTimeBuff(unit, buff)
	local time, expires = 0, select(7, UnitBuff(unit, buff))	
	
	if expires ~= nil then 
		time = expires - GetTime() 
	else--Verify again
		local a = UnitBuff(unit, buff)	
		if a ~= nil then time = 1 end
	end 
	
	return BtnActiveRT:FormatTime(time)
end

function BtnActiveRT:GetCastSpell(unit)
	local spell = select(1, UnitCastingInfo(unit))
	if spell == nil then spell = select(1, UnitChannelInfo(unit)) end
	return spell
end

function BtnActiveRT:GetKeyTable(i)
	local id, name = GetActionInfo(i)

	if id == "item" then return GetItemInfo(name)
	elseif id == "spell" then return GetSpellInfo(name)
	elseif id == "macro" then return GetMacroInfo(name)
	else return nil	end
end

function BtnActiveRT:IsUsable(spell)
	for i = 1, NUM_TABLE_SLOTS, 1 do
		if BtnActiveRT:GetKeyTable(i) == spell then return true end
	end	
	return false
end

function BtnActiveRT:IsGlyph(glyph)
	for i = 1, NUM_GLYPH_SLOTS do
		local id = select(4, GetGlyphSocketInfo(i))		
		if select(1, GetSpellInfo(id)) == glyph then return true end
	end
	return false
end

function BtnActiveRT:GetTimePlayerSpell(spell)
	if not BtnActiveRT:IsUsable(spell) then return -1 end
	
	local start, dur = GetSpellCooldown(spell)	
	return BtnActiveRT:FormatTime(((dur + start) - GetTime()) )
end

function BtnActiveRT:GetTimePlayerSpellSimulacro(spell)
	local start, dur = GetSpellCooldown(spell)	
	return BtnActiveRT:FormatTime(((dur + start) - GetTime()) -1)
end

function BtnActiveRT:GetTimePlayerTouchofKarma()
	local karma, _, _, _, _, dur, expires, caster = UnitDebuff("player", TargetSpell["Touch of Karma"])
	local time = 0
	
	if expires ~= nil then 
		time = expires - GetTime() 
	else--Verify again
		local a = UnitDebuff("player", TargetSpell["Touch of Karma"])	
		if a ~= nil then time = 1 end
	end
	
	return BtnActiveRT:FormatTime(time)
end

function BtnActiveRT:IsTargetDispell()
	for item in pairs(TargetDisspell) do 	
		if UnitBuff("target", TargetDisspell[item]) ~= nil then return true end
	end		
	return false
end

function BtnActiveRT:IsCastingFear(spell)
	for item in pairs(CastingFear) do 
		if item == spell then return true end
	end
	
	return false
end

function BtnActiveRT:IsDesecratedGround(unit)
	local a = UnitBuff(unit, PlayerSpell["Desecrated Ground"])	
	return a ~= nil
end

function BtnActiveRT:GetTimeInterruptibleSpell(unit)
	local spell, subText, text, texture, startTime, endTime, isTradeSkill, castID, isInterruptible = UnitCastingInfo(unit)	
	local time = 0
	
	if spell == nil then 
		spell, subText, text, texture, startTime, endTime, isTradeSkill, isInterruptible = UnitChannelInfo(unit)
	end	
	
	if spell ~= nil then	
		time = BtnActiveRT:FormatTime((BtnActiveRT:FormatTime(endTime) - string.format( "%d000",  GetTime())) / 1000) -1
	end
	
	return time
end

function BtnActiveRT:GetTimeTargetDisease(disease)
	local time, expires = 0, select(7, UnitDebuff("target", disease, nil, "player"))
	if expires ~= nil then time = expires - GetTime() end	
	return BtnActiveRT:FormatTime(time)
end

function BtnActiveRT:GetTimeSpellSilence(unit)
	local time = 0	
	
	for item in pairs(SpellSilence) do 
		time = BtnActiveRT:GetTimeDebuff(unit, SpellSilence[item]) if time > 0 then return time end		
	end
	
	return 0
end
	
function BtnActiveRT:GetTimeTargetSilenceImmunezed()
	local time = 0	
	
	for item in pairs(SilenceImmunezed) do 
		time = BtnActiveRT:GetTimeBuff("target", SilenceImmunezed[item]) if time > 0 then return time end		
	end		

	return 0
end

function BtnActiveRT:GetTimeTargetAtackImmunezed()
	local time = BtnActiveRT:GetTimeBuff("target", AtackImmunezed["Deterrence"]) if time > 0 then return time end	
	time = BtnActiveRT:GetTimeBuff("target", AtackImmunezed["Unending Resolve"]) if time > 0 then return time end		
	time = BtnActiveRT:GetTimeBuff("target", AtackImmunezed["Mass Spell Reflection"]) if time > 0 then return time end	
	time = BtnActiveRT:GetTimeBuff("target", AtackImmunezed["Bladestorm"]) if time > 0 then return time end		
	time = BtnActiveRT:GetTimeBuff("target", AtackImmunezed["Diffuse Magic"]) if time > 0 then return time end	
	time = BtnActiveRT:GetTimeBuff("target", AtackImmunezed["Ice Block"]) if time > 0 then return time end		
	time = BtnActiveRT:GetTimeBuff("target", AtackImmunezed["Divine Shield"]) if time > 0 then return time end	
	time = BtnActiveRT:GetTimeBuff("target", AtackImmunezed["Anti-Magic Shell"]) if time > 0 then return time end
	time = BtnActiveRT:GetTimeDebuff("target", AtackImmunezed["Fear"]) if time > 0 then return time end
	time = BtnActiveRT:GetTimeDebuff("target", AtackImmunezed["Hex"]) if time > 0 then return time end
	time = BtnActiveRT:GetTimeDebuff("target", AtackImmunezed["Polymorph"]) if time > 0 then return time end
	time = BtnActiveRT:GetTimeDebuff("target", AtackImmunezed["Frostjaw"]) if time > 0 then return time end
	time = BtnActiveRT:GetTimeDebuff("target", AtackImmunezed["Psychic Scream"]) if time > 0 then return time end
	time = BtnActiveRT:GetTimeDebuff("target", AtackImmunezed["Cyclone"]) if time > 0 then return time end
	return 0
end
						
function BtnActiveRT:GetTimeTargetSpellFrozen()
	local time = BtnActiveRT:GetTimeSpellSilence("target") if time > 0 then return time end 
	
	for item in pairs(SpellFrozen) do 
		time = BtnActiveRT:GetTimeDebuff("target", SpellFrozen[item]) if time > 0 then return time end		
	end
	
	return 0
end

function BtnActiveRT:GetTimeTargetFrozenImmunezed()
	local time = BtnActiveRT:GetTimeTargetAtackImmunezed() if time > 0 then return time end 
	time = BtnActiveRT:GetTimeBuff("target", FrozenImmunezed["Master Call"]) if time > 0 then return time end	
	time = BtnActiveRT:GetTimeBuff("target", FrozenImmunezed["Avatar"]) if time > 0 then return time end	
	time = BtnActiveRT:GetTimeBuff("target", FrozenImmunezed["Phantasm"]) if time > 0 then return time end	
	return 0
end

function BtnActiveRT:IsTargetClassMana()
	--Warrior = 1
	--Paladin = 2
	--Hunter = 3
	--Rogue = 4
	--Priest = 5
	--DeathKnight = 6
	--Shaman = 7
	--Mage = 8
	--Warlock = 9
	--Monk = 10
	--Druid = 11
	local classeTarget = select(3, UnitClass("target"))
	if classeTarget == 2 
	or classeTarget == 5 
	or classeTarget == 7
	or classeTarget == 8
	or classeTarget == 9
	or classeTarget == 11 then return true end
	return false
end

function BtnActiveRT:GetTargetRange(unit)
	local rangeTarget = 0

	if BtnActiveRT:IsUsable(PlayerSpell["Plague Strike"]) and IsSpellInRange(PlayerSpell["Plague Strike"], unit) == 1 then
		rangeTarget = 5
	elseif CheckInteractDistance(unit, 3) and UnitName(unit) ~= UnitName("player") then
		rangeTarget = 9
	elseif CheckInteractDistance(unit, 2) and UnitName(unit) ~= UnitName("player") then
		rangeTarget = 11
	elseif (CheckInteractDistance(unit, 4) or CheckInteractDistance(unit, 1)) and UnitName(unit) ~= UnitName("player") then
		rangeTarget = 28	
	elseif BtnActiveRT:IsUsable(PlayerSpell["Icy Touch"]) and IsSpellInRange(PlayerSpell["Icy Touch"], unit) == 1 then
		rangeTarget = 30	
	elseif BtnActiveRT:IsUsable(PlayerSpell["Death Grip"]) and IsSpellInRange(PlayerSpell["Death Grip"], unit) == 1 and BtnActiveRT:IsGlyph(PlayerGlyph["Glyph Death Grip"]) then
		rangeTarget = 35
	elseif BtnActiveRT:IsUsable(PlayerSpell["Dark Simulacrum"]) and IsSpellInRange(PlayerSpell["Dark Simulacrum"], unit) == 1 and BtnActiveRT:IsSimulacro() then
		rangeTarget = 40
	else			
		rangeTarget = 100			
	end
	
	return rangeTarget
end

function BtnActiveRT:GetBloodCharge()
	local charges = select(4, UnitBuff("player", PlayerSpell["Blood Charge"]))
	if charges == nil then return 0 else return charges end
end

local CurTimerFall = 0		
local UpdateTimerFall = 0	
function BtnActiveRT:GetTimePlayerFalling()
	if IsFalling() == true then 
		CurTimerFall = GetTime()
	else
		UpdateTimerFall = GetTime()
	end		
	
	local time = CurTimerFall - UpdateTimerFall	
	if time < 0 then time = 0 end	
	return BtnActiveRT:FormatTime(time)
end

function BtnActiveRT:IsPreparingAction()
	local frame = GetMouseFocus()	
	
	if frame ~= nil then
		local name = GetMouseFocus():GetName()
		
		if name ~= nil then
			local pos = select(2,string.find(name, NAME_ADDON_BAR))

			if pos ~= nil then 
				local i = strsub(name, pos+1, pos +2)
				
				if BtnActiveRT:GetKeyTable(i) == PlayerSpell["Death and Decay"] 
				or BtnActiveRT:GetKeyTable(i) == PlayerSpell["Defile"]
				or BtnActiveRT:GetKeyTable(i) == PlayerSpell["Army of the Dead"]
				or BtnActiveRT:GetKeyTable(i) == select(1, GetSpellInfo(PlayerSpell["Dark Simulacrum"]))
				or BtnActiveRT:GetKeyTable(i) == PlayerSpell["Dark Simulacrum"]			
				or BtnActiveRT:GetKeyTable(i) == PlayerSpell["Remorseless Winter"]
				or BtnActiveRT:GetKeyTable(i) == PlayerSpell["Shadowmeld"]
				or BtnActiveRT:GetKeyTable(i) == PlayerSpell["Chains of Ice"]
				or BtnActiveRT:GetKeyTable(i) == PlayerSpell["Asphyxiate"]
				or BtnActiveRT:GetKeyTable(i) == PlayerSpell["Strangulate"]
				or BtnActiveRT:GetKeyTable(i) == PlayerSpell["Raise Ally"]
				or BtnActiveRT:GetKeyTable(i) == PlayerSpell["Artillery Strike"]
				or BtnActiveRT:GetKeyTable(i) == PlayerSpell["Call to Arms"]
				or BtnActiveRT:GetKeyTable(i) == PlayerSpell["Summon Mechashredder 5000"]
				or BtnActiveRT:GetKeyTable(i) == PlayerItem["Hardened Shell"]
				or BtnActiveRT:GetKeyTable(i) == PlayerItem["Super Sticky Glitter Bomb"]			
				or BtnActiveRT:GetKeyTable(i) == PlayerItem["Frost Grenade"] then
					return true
				end
			end
		end
	end
	
	return false
end

function BtnActiveRT:IsSimulacro()
	return select(1, GetSpellInfo(PlayerSpell["Dark Simulacrum"])) == PlayerSpell["Dark Simulacrum"] 
end

function BtnActiveRT:IsNotSimulacroBad(Spell)
	return select(1, GetSpellInfo(PlayerSpell["Dark Simulacrum"])) ~= Spell
end

function BtnActiveRT:IsActivedConversion()
	return UnitBuff("player", PlayerSpell["Conversion"]) ~= nil
end

local MinTimeEnterBG = 3
local TimeEnterBG = MinTimeEnterBG
local CurTimerBG = 0		
local UpdateTimerBG = 0	
function BtnActiveRT:TimeEnterBG()	
	CurTimerBG = GetTime()
	
	if (CurTimerBG - UpdateTimerBG > 1) then
		UpdateTimerBG = CurTimerBG
		TimeEnterBG = MinTimeEnterBG
		
		for i=1, GetNumBattlegroundTypes() do a, b, c, d, e, f, g = GetBattlefieldStatus(i) 
			if a == "confirm" then 			
				TimeEnterBG = GetBattlefieldPortExpiration(i)
				if TimeEnterBG > 0 and TimeEnterBG <= 10 then
					BtnActiveRT:SendMessage("Enter Battle " .. TimeEnterBG .. "s", false)
				end
				break 
			end
		end	
	end
	
	if TimeEnterBG <= 0 then return MinTimeEnterBG end
	
	return TimeEnterBG
end

function BtnActiveRT:Main()	
	if BtnActiveRT:TimeEnterBG() < MinTimeEnterBG and not UnitIsDeadOrGhost("player") then 
		return "Enter Battle"
	end	

	if BtnActiveRT:GetCastSpell("player") ~= nil 
	or BtnActiveRT:IsPreparingAction()
	or BtnActiveRT:IsUsable(PlayerSpell["Death and Decay"]) and IsCurrentSpell(PlayerSpell["Death and Decay"]) 
	or BtnActiveRT:IsUsable(PlayerSpell["Defile"]) and IsCurrentSpell(PlayerSpell["Defile"]) 
	or IsCurrentItem(PlayerItem["Frost Grenade"])
	or (not BtnActiveRT:IsSimulacro() and IsCurrentSpell(GetSpellInfo(PlayerSpell["Dark Simulacrum"])))
	or UnitIsDeadOrGhost("player")
	or UnitHasVehicleUI("player")
	or IsStealthed() then return nil end
	
	local TimePlayerFalling = BtnActiveRT:GetTimePlayerFalling()
	local PlayerIsDK = (select(3, UnitClass("player")) == 6)
	local PlayerPresence = GetShapeshiftForm()
	local PlayerInCombat = UnitAffectingCombat("player")
	local PlayerSpeed = BtnActiveRT:FormatTime(select(1, GetUnitSpeed("player")))
	local PlayerMounted = IsMounted()
	local PlayerLife = UnitHealth("player")/UnitHealthMax("player")
	local TimePlayerSilence = BtnActiveRT:GetTimeSpellSilence("player")

	if TimePlayerSilence > 0 then
		BtnActiveRT:SendMessage("I lost control. Helpme!", true)
	end
	
	if TimePlayerFalling >= 1 and PlayerIsDK
	and BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Path of Frost"]) == 0 
	and BtnActiveRT:IsGlyph(PlayerGlyph["Glyph Path of Frost"]) 		
	and BtnActiveRT:GetTimeBuff("player", PlayerSpell["Path of Frost"]) == 0 then 
		return PlayerSpell["Path of Frost"]
	end	

	if UnitIsAFK("Player") or (Behind and PlayerSpeed == 0) then 
		BtnActiveRT:BehindNow(false)
		return "Behind" 
	end

	if PlayerPresence == PRESENCE_FROST then 
		MAX_RUNES_FROST_STRIKE = 25 
		MAX_RUNES_PLAGUE_STRIKE = 12	
	else
		MAX_RUNES_FROST_STRIKE = 40
		MAX_RUNES_PLAGUE_STRIKE = 10
	end
	
	for i=1, 40 do 
		local B=UnitBuff("player",i)
		if B == PlayerSpell["Telaari Talbuk"] then 
			PlayerMounted = false 
			break
		end 
	end

	if PlayerIsDK then
		--Presence Speed
		if PlayerPresence ~= PRESENCE_UNHOLY
		and TimePlayerFalling < 2 
		and (not PlayerInCombat or not UnitCanAttack("player", "target"))
		and (PlayerSpeed >= 7 or PlayerMounted) then 
			if BtnActiveRT:IsGlyph(PlayerGlyph["Glyph of Shifting Presences"]) 
			or UnitPower("player") < MAX_RUNES_FROST_STRIKE then
				return PlayerSpell["Unholy Presence"]
			end	
		end
		
		--Presence Atack
		if PlayerPresence ~= PRESENCE_FROST
		and TimePlayerFalling < 2 and PlayerInCombat and PlayerLife >= MIN_LIFE and UnitCanAttack("player", "target") then 
			if BtnActiveRT:IsGlyph(PlayerGlyph["Glyph of Shifting Presences"])
			or UnitPower("player") < MAX_RUNES_FROST_STRIKE then
				return PlayerSpell["Frost Presence"]
			end		
		end	
		
		--Presence Defend
		if PlayerPresence ~= PRESENCE_BLOOD
		and	(TimePlayerFalling >= 2 or (PlayerInCombat and PlayerLife < MIN_LIFE and UnitCanAttack("player", "target")))
		then 
			if BtnActiveRT:IsGlyph(PlayerGlyph["Glyph of Shifting Presences"])
			or UnitPower("player") < MAX_RUNES_FROST_STRIKE then
				return PlayerSpell["Blood Presence"]
			end	
		end
		
		--Heal to live
		if BtnActiveRT:IsUsable(PlayerSpell["Conversion"]) then
			if PlayerLife == 1 then 
				if BtnActiveRT:IsActivedConversion() then CancelUnitBuff("player", PlayerSpell["Conversion"]) end
			end
			if PlayerLife < MIN_LIFE and not BtnActiveRT:IsActivedConversion() and UnitPower("player") >= MIN_CONVERTION then
				return PlayerSpell["Conversion"]
			end
		end
		
		if PlayerLife <= 0.5 and BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Death Pact"]) == 0 then return PlayerSpell["Death Pact"] end
		
		if PlayerLife < 0.4 and BtnActiveRT:IsGlyph(PlayerGlyph["Glyph of Empowerment"]) 
		and BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Empower Rune Weapon"]) == 0 then return PlayerSpell["Empower Rune Weapon"] end
	end

	if not UnitCanAttack("player", "target") or UnitIsDeadOrGhost("target") or (PlayerMounted and PlayerSpeed > 0) then return nil end		
	
	--Rotation	
	local TimeTargetDiseaseNecrotic = BtnActiveRT:GetTimeTargetDisease(PlayerSpell["Necrotic Plague"])
	local TimeTargetDiseaseBlood = BtnActiveRT:GetTimeTargetDisease(PlayerSpell["Blood Plague"])
	local TimeTargetDiseaseFrost = BtnActiveRT:GetTimeTargetDisease(PlayerSpell["Frost Fever"])
	local TimeTargetSilenced = BtnActiveRT:GetTimeSpellSilence("target")
	local TimeTargetSilenceImmunezed = BtnActiveRT:GetTimeTargetSilenceImmunezed()	
	local TimeTargetFrozen = BtnActiveRT:GetTimeTargetSpellFrozen()
	local TimeTargetFrozenImmunezed = BtnActiveRT:GetTimeTargetFrozenImmunezed()
	local TimeTargetAtackImmunezed = BtnActiveRT:GetTimeTargetAtackImmunezed()
	local TimeTargetInterruptibleSpell = BtnActiveRT:GetTimeInterruptibleSpell("target")	
	local TimePlayerTouchofKarma = BtnActiveRT:GetTimePlayerTouchofKarma()
	local TimeRemorseless = BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Remorseless Winter"])	
	local TargetIsPlayer = UnitIsPlayer("target")
	local TargetRange = BtnActiveRT:GetTargetRange("target")
	local TargetLife = UnitHealth("target")/UnitHealthMax("target")
	local TargetSpeed = BtnActiveRT:FormatTime(select(1, GetUnitSpeed("target")))

	if TimePlayerTouchofKarma > 0 then
		BtnActiveRT:SendMessage(TargetSpell["Touch of Karma"] .. " casted. Wait " .. TimePlayerTouchofKarma .. "s", MSG_SAY_ALL)
	elseif TimeTargetAtackImmunezed > 0 then	
		BtnActiveRT:SendMessage(UnitName("target") .. " is Immune to atack. Wait " .. TimeTargetAtackImmunezed .. "s", MSG_SAY_ALL)
	elseif TimeTargetSilenceImmunezed > 0 then
		BtnActiveRT:SendMessage(UnitName("target") .. " is Immune to silence. Wait " .. TimeTargetSilenceImmunezed .. "s", MSG_SAY_ALL)
	elseif BtnActiveRT:IsDesecratedGround("target") then
		BtnActiveRT:SendMessage(UnitName("target") .. " is immune to loss controle.", MSG_SAY_ALL)
	end
	
	if not PlayerIsDK then return nil end
	
	--Buff
	if BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Horn of Winter"]) == 0 
	and BtnActiveRT:GetTimeBuff("player", PlayerSpell["Horn of Winter"]) == 0 
	and PlayerInCombat and not PlayerMounted then return PlayerSpell["Horn of Winter"] end
	
	--Defensive	
	if BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Anti-Magic Shell"]) == 0 and not BtnActiveRT:IsDesecratedGround("player") then
		if BtnActiveRT:GetTimeBuff("target", PlayerSpell["Remorseless Winter"]) > 0
		or (PlayerLife < MIN_LIFE and TargetRange <= 30 and (BtnActiveRT:IsTargetClassMana() or PlayerLife < 0.6) and PlayerInCombat and not PlayerMounted) then
			return PlayerSpell["Anti-Magic Shell"]
		end
	end
	
	--Cast
	if TimeTargetInterruptibleSpell == 1 and not BtnActiveRT:IsDesecratedGround("player") then		
		if BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Mind Freeze"]) == 0 
		and IsSpellInRange(PlayerSpell["Mind Freeze"] , "target") == 1
		and BtnActiveRT:GetTimeBuff("player", PlayerSpell["Anti-Magic Shell"]) == 0 
		and TargetIsPlayer and TimeTargetAtackImmunezed == 0 then
			return PlayerSpell["Mind Freeze"] 
		elseif BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Anti-Magic Shell"]) == 0
		and BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Mind Freeze"] ) > 0 
		and TargetRange <= 30 then
			return PlayerSpell["Anti-Magic Shell"]
		elseif BtnActiveRT:IsCastingFear(BtnActiveRT:GetCastSpell("target"))
		and BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Lichborne"]) == 0
		and BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Mind Freeze"] ) > 0 
		and BtnActiveRT:GetTimeBuff("player", PlayerSpell["Anti-Magic Shell"]) == 0 then
			return PlayerSpell["Lichborne"]
		end		
	end
	
	--Behind
	if Behind and BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Chains of Ice"]) == 0 and IsSpellInRange(PlayerSpell["Chains of Ice"], "target") == 1 
	and TimeTargetFrozen == 0 and TimeTargetFrozenImmunezed == 0 and TargetSpeed >= 5 then
		return PlayerSpell["Chains of Ice"]
	end		

	--Range	
	if TargetIsPlayer and TargetRange >= 9 then	
		if BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Death Grip"]) == 0 and IsSpellInRange(PlayerSpell["Death Grip"], "target") == 1 
		and TimeTargetFrozenImmunezed == 0 and (PlayerSpeed == 0 or PlayerSpeed > 7) and not Behind	then
			return PlayerSpell["Death Grip"] 
		end
	end

	if TimeTargetAtackImmunezed == 0 then
		--Silence	
		if TargetIsPlayer then
			if TimeTargetSilenceImmunezed == 0 and not BtnActiveRT:IsDesecratedGround("target") then	
				local Silence = nil
				
				if BtnActiveRT:IsUsable(PlayerSpell["Asphyxiate"]) then Silence = PlayerSpell["Asphyxiate"]
				elseif BtnActiveRT:IsUsable(PlayerSpell["Strangulate"]) then Silence = PlayerSpell["Strangulate"] end	
			
				if TargetRange <= 11 and TimeRemorseless == 0 then
					return PlayerSpell["Remorseless Winter"]
				end
				
				if TimeTargetSilenced < 1 and BtnActiveRT:GetTimePlayerSpell(Silence) == 0 and TargetRange <= 30 then	
					return Silence	
				end
			end
			
			if BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Pillar of Frost"]) == 0	and TargetRange <= 11 then
				return PlayerSpell["Pillar of Frost"]
			end	
		end
		
		--Over Runic Power
		if BtnActiveRT:IsUsable(PlayerSpell["Frost Strike"]) and TargetRange <= 5 
		and (
			(UnitPower("player") >= 70 and PlayerPresence ~= PRESENCE_FROST) 
			or
			(UnitPower("player") >= 40 and PlayerPresence == PRESENCE_FROST)
			) then 		
			return PlayerSpell["Frost Strike"]
		end	
		
		--Over Blood Charge
		if BtnActiveRT:GetBloodCharge() > 9 
		and (BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Howling Blast"]) > 1 or BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Obliterate"]) > 1) then
			return PlayerSpell["Blood Tap"] 
		end
		
		--Range	
		if TargetIsPlayer and TargetRange > 5 then			
			if BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Chains of Ice"]) == 0 and IsSpellInRange(PlayerSpell["Chains of Ice"], "target") == 1 
			and TimeTargetFrozen == 0 and TimeTargetFrozenImmunezed == 0 and TargetSpeed >= 5 then
				return PlayerSpell["Chains of Ice"] 
			end

			if BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Howling Blast"]) == 0 and IsSpellInRange(PlayerSpell["Howling Blast"], "target") == 1 
			and TargetRange > 11 and PlayerLife >= MIN_LIFE then
				return PlayerSpell["Howling Blast"] 
			end
		end	
		
		--Active Runes fully depleted	
		if BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Obliterate"]) >= 2 and BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Plague Leech"]) == 0 then
			if TimeTargetDiseaseNecrotic > 1 then return PlayerSpell["Plague Leech"] end
			
			if TimeTargetDiseaseBlood > 1 and TimeTargetDiseaseFrost > 1 then return PlayerSpell["Plague Leech"] end
		
			if TimeTargetDiseaseBlood <= 2 and TimeTargetDiseaseFrost > 1 
			and BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Plague Strike"]) == 0 and IsSpellInRange(PlayerSpell["Plague Strike"], "target") == 1 then
				return PlayerSpell["Plague Strike"]
			end
		end		
	
		--Active Atack 1
		if BtnActiveRT:GetTimeBuff("player", PlayerSpell["Killing Machine"]) > 0 
		and UnitPower("player") < MAX_RUNES_FROST_STRIKE and (UnitPower("player") + MAX_RUNES_PLAGUE_STRIKE) >= MAX_RUNES_FROST_STRIKE then	
			if BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Plague Strike"]) == 0 and IsSpellInRange(PlayerSpell["Plague Strike"], "target") == 1 then
				return PlayerSpell["Plague Strike"] 
			end
			
			if BtnActiveRT:GetBloodCharge() >= MIN_BLOOD_CHARGE then return PlayerSpell["Blood Tap"] end
		end
	
		--Atack 1
		if BtnActiveRT:IsUsable(PlayerSpell["Frost Strike"]) and UnitPower("player") >= MAX_RUNES_FROST_STRIKE and TargetRange <= 5
		and BtnActiveRT:GetTimeBuff("player", PlayerSpell["Killing Machine"]) > 0 then
			return PlayerSpell["Frost Strike"]
		end
		
		--Simulacro from DK
		if BtnActiveRT:IsSimulacro() and BtnActiveRT:IsTargetClassMana() and UnitPower("player") >= 20
		and BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Dark Simulacrum"]) == 0 and IsSpellInRange(PlayerSpell["Dark Simulacrum"] , "target") == 1 then
			return PlayerSpell["Dark Simulacrum"]
		end		
	end
	
	--Free Spell heal
	if BtnActiveRT:GetTimeBuff("player", PlayerSpell["Dark Succor"]) > 0
	and BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Death Strike"]) == 0 and IsSpellInRange(PlayerSpell["Death Strike"], "target") == 1 then 
		if PlayerLife < MIN_LIFE  or (TimeTargetAtackImmunezed > 0 and PlayerLife < 1)
		or BtnActiveRT:GetTimeBuff("player", PlayerSpell["Dark Succor"]) <= 5 then return PlayerSpell["Death Strike"] end
	end	
			
	--Healing		
	if PlayerLife < MIN_LIFE or (TimeTargetAtackImmunezed > 0 and PlayerLife < 1) then
		if BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Death Siphon"]) == 0 and TargetRange <= 40 then
			return PlayerSpell["Death Siphon"]
		end
		
		if BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Death Strike"]) == 0 and IsSpellInRange(PlayerSpell["Death Strike"], "target") == 1 then
			return PlayerSpell["Death Strike"]
		end
		
		if BtnActiveRT:GetBloodCharge() >= MIN_BLOOD_CHARGE then return PlayerSpell["Blood Tap"] end
	end
	
	--Atack
	if TimeTargetAtackImmunezed == 0 then		
		if TargetIsPlayer then
			--Disease target mouseover
			if ((TimeTargetDiseaseBlood > 1 and TimeTargetDiseaseFrost > 1) or TimeTargetDiseaseNecrotic > 1)
			and BtnActiveRT:GetTargetRange("mouseover") < 10 and UnitName("target") ~= UnitName("mouseover")
			and UnitName("player") ~= UnitName("mouseover")
			and BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Blood Boil"]) == 0 and TargetRange < 10 then 
				return PlayerSpell["Blood Boil"] 
			end
			
			--Defile
			if TargetSpeed == 0 and PlayerSpeed == 0 and TargetRange <= 9 then
				if BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Defile"]) == 0 then
					return PlayerSpell["Defile"]
				end
				
				--Slow target
				if BtnActiveRT:IsGlyph(PlayerGlyph["Glyph of Death and Decay"]) and BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Death and Decay"]) == 0 then
					return PlayerSpell["Death and Decay"]
				end
			end
	
			--Execute
			if TargetLife < MAX_SOUL_REAPER_LIFE then
				if BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Soul Reaper"]) > 0 and IsSpellInRange(PlayerSpell["Soul Reaper"], "target") == 1 then
					if BtnActiveRT:GetBloodCharge() >= MIN_BLOOD_CHARGE then return PlayerSpell["Blood Tap"] end
				elseif IsSpellInRange(PlayerSpell["Soul Reaper"], "target") == 1 then
					return PlayerSpell["Soul Reaper"]
				end
			end
		end
	
		--Disease		
		if (TimeTargetDiseaseBlood < 2 or TimeTargetDiseaseFrost < 2) and TimeTargetDiseaseNecrotic == 0 then	
			if BtnActiveRT:IsUsable(PlayerSpell["Outbreak"]) and BtnActiveRT:IsGlyph(PlayerGlyph["Glyph of Outbreak"]) then
				if UnitPower("player") >= MIN_OUTBREAK and IsSpellInRange(PlayerSpell["Outbreak"], "target") == 1 then 
					return PlayerSpell["Outbreak"] 
				end
			elseif BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Outbreak"]) == 0 and IsSpellInRange(PlayerSpell["Outbreak"], "target") == 1 then
				return PlayerSpell["Outbreak"] 
			end
			
			if BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Unholy Blight"]) == 0 and TargetRange <= 11 then 
				return PlayerSpell["Unholy Blight"]
			elseif not BtnActiveRT:IsUsable(PlayerSpell["Unholy Blight"]) and not BtnActiveRT:IsUsable(PlayerSpell["Plague Leech"]) then
				if TimeTargetDiseaseBlood < 2
				and BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Plague Strike"]) == 0 and IsSpellInRange(PlayerSpell["Plague Strike"], "target") == 1 then
					return PlayerSpell["Plague Strike"]
				end
			end
		end
		
		--Dispel
		if BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Howling Blast"]) == 0 and IsSpellInRange(PlayerSpell["Howling Blast"], "target") == 1 then
			if BtnActiveRT:IsUsable(PlayerSpell["Icy Touch"]) and BtnActiveRT:IsGlyph(PlayerGlyph["Glyph of Icy Touch"]) and BtnActiveRT:IsTargetDispell() then 
				return PlayerSpell["Icy Touch"]
			--Fog
			elseif BtnActiveRT:GetTimeBuff("player", PlayerSpell["Freezing Fog"]) > 0 then
				return PlayerSpell["Howling Blast"] 
			end
		end
	
		--Atack 2
		if (BtnActiveRT:GetTimeBuff("player", PlayerSpell["Killing Machine"]) > 0) then
			if BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Obliterate"]) > 1 and IsSpellInRange(PlayerSpell["Obliterate"], "target") == 1 then
				if BtnActiveRT:GetBloodCharge() >= MIN_BLOOD_CHARGE then return PlayerSpell["Blood Tap"] end
			elseif IsSpellInRange(PlayerSpell["Obliterate"], "target") == 1 then
				return PlayerSpell["Obliterate"] 
			end	
		end
		
		--Simulacrun others classes
		if not BtnActiveRT:IsSimulacro() and TargetRange <= 30
		and BtnActiveRT:GetTimePlayerSpellSimulacro(PlayerSpell["Dark Simulacrum"]) == 0
		and BtnActiveRT:IsNotSimulacroBad(TargetSpell["Avenger's Shield"]) then
			return PlayerSpell["Dark Simulacrum"]
		end	
	
		--Atack 3
		if BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Howling Blast"]) == 0 and IsSpellInRange(PlayerSpell["Howling Blast"], "target") == 1 then
			return PlayerSpell["Howling Blast"]
		end
	
		--Refresh Runes
		if TargetIsPlayer then
			if not BtnActiveRT:IsGlyph(PlayerGlyph["Glyph of Empowerment"]) 
			and BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Empower Rune Weapon"]) == 0
			and IsSpellInRange(PlayerSpell["Obliterate"], "target") == 1
			and BtnActiveRT:GetTimeBuff("player", PlayerSpell["Killing Machine"]) > 0
			and (BtnActiveRT:GetTimePlayerSpell(PlayerSpell["Obliterate"]) >= 1 or UnitPower("player") < MAX_RUNES_FROST_STRIKE) then 
				return PlayerSpell["Empower Rune Weapon"] 
			end
		end
	end

	return nil
end